// src/simulation_statistics_widget.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef SIMULATION_STATISTICS_WIDGET_HH
#define SIMULATION_STATISTICS_WIDGET_HH 1

#include "config.h"

#include <sgpemv2/history_observer.hh>

#include <gtkmm/treeview.h>
#include <gtkmm/treestore.h>

namespace sgpem
{

	
	class TabularSimulationStatisticsWidget : public HistoryObserver, public Gtk::TreeView
	{	
	public:	
		TabularSimulationStatisticsWidget();
		virtual ~TabularSimulationStatisticsWidget();
		
		void 		update(const History& changed_history);
	

	protected:
		

		Glib::RefPtr<Gtk::TreeStore> 		_model;				//treeview stuffs
		Gtk::TreeModelColumnRecord 			_columns;
		
		Gtk::TreeModelColumn<Glib::ustring> _col_inactivity;	//all columns
		Gtk::TreeModelColumn<Glib::ustring>	_col_progress;
		Gtk::TreeModelColumn<Glib::ustring>	_col_turn;
		Gtk::TreeModelColumn<Glib::ustring>	_col_response;
		Gtk::TreeModelColumn<Glib::ustring>	_col_effic;
		Gtk::TreeModelColumn<Glib::ustring>	_col_term_procs;
		Gtk::TreeModelColumn<Glib::ustring>	_col_term_threads;
		Gtk::TreeModelColumn<Glib::ustring>	_col_through_procs;
		Gtk::TreeModelColumn<Glib::ustring>	_col_through_threads;
	
	};

} //~ namespace sgpem


#endif
